####################################################
# machine-dependent stuff and overrides of std defs
# HP700 - cfront (CC)

# no ios lib for cfront
IOS_LIB = 
IBERTY_LIB = -lmyiberty

# use the CC includes
IOS_INCLUDES = CC-3.1

#include CC iostream stuff
IDIRS_EXTRA = -I/usr/include/CC

#include x libs, and /lib/pa.1.1  for mathf functions
LDIRS_EXTRA = -L/usr/lib/X11R5 -L/lib/pa1.1/

# need pa1.1 version of libM for mathf functions
GENERIC_LIB = -lm -lM

DEFINES = -DNO_SIGNED -DNO_BUILTIN_BOOL

# using cfront translator (+T)
CXX_SHARED = CC +Z +T +a1 +e0 -D__ANSI_CPP__
CC_SHARED = gcc -fPIC -U__GNUG__ -nostdinc -I/usr/include
CXX_NONSHARED = CC +T +a1 +e0 -D__ANSI_CPP__
CC_NONSHARED = gcc -U__GNUG__ -nostdinc -I/usr/include

# doesn't need ranlib
RANLIB = ls
AR_CMD_SHARED = CC +Z +T +a1 -b -o
LIB_EXT_SHARED = sl

#cppC = /usr/lib/Cpp.ansi -I/usr/include/CC
# use gnu cccp instead cuz it works! (and don't include standard stuff..)
cppC = /usr/local/bin/cccp -lang-c++ -nostdinc++

# using shared libraries
CC = $(CC_SHARED)
CXX = $(CXX_SHARED)
# CC doesn't understand -M
DEP_CXX = $(CC)
LIB_EXT = $(LIB_EXT_SHARED)
AR_CMD = $(AR_CMD_SHARED)

# SIM_NONSHARED in the default non-shared settings?
# performance on small networks is worse, but large is same
# space savings probably weighs in favor of all shared given
# marginal benefits for reasonably large networks
SIM_NONSHARED_CXX = $(CXX_SHARED)
SIM_NONSHARED_AR_CMD = $(AR_CMD_SHARED)
SIM_NONSHARED_LIB_EXT = $(LIB_EXT_SHARED)

# debug g1 only does debug info once!
DEBUG_FLAG = -g1
DEBUG_OPT_FLAG = 
OPT_FLAG = -O

# vt file needed for e0/e1 stuff
VT_INST_SRC = $(VT_INST_FILE).cc
VT_INST_OBJ = $(VT_INST_FILE).o
VT_INST_DEP = $(VT_INST_FILE).d

# using old cfront for _TA.cc files
MAKETA_FLAGS_CPU = -old_cfront

